org.vertx.java.core.parsetools

## Class RecordParser

- java.lang.Object
- - org.vertx.java.core.parsetools.RecordParser

All Implemented Interfaces:
  Handler<Buffer>

    public class RecordParser
    extends java.lang.Object
    implements Handler<Buffer>

A helper class which allows you to easily parse protocols which are delimited by a sequence of bytes, or fixed size records.

Instances of this class take as input `Buffer` instances containing raw bytes, and output records.

For example, if I had a simple ASCII text protocol delimited by '\n' and the input was the following:

     buffer1:HELLO\nHOW ARE Y
     buffer2:OU?\nI AM
     buffer3: DOING OK
     buffer4:\n

Then the output would be:

     buffer1:HELLO
     buffer2:HOW ARE YOU?
     buffer3:I AM DOING OK

Instances of this class can be changed between delimited mode and fixed size record mode on the fly as individual records are read, this allows you to parse protocols where, for example, the first 5 records might all be fixed size (of potentially different sizes), followed by some delimited records, followed by more fixed size records.

Instances of this class can't currently be used for protocols where the text is encoded with something other than a 1-1 byte-char mapping. TODO extend this class to cope with arbitrary character encodings

### Method Summary

Methods
`void` `delimitedMode(byte[] delim)` Flip the parser into delimited mode, and where the delimiter can be represented by the delimiter `delim`.
`void` `delimitedMode(java.lang.String delim)` Flip the parser into delimited mode, and where the delimiter can be represented by the String `delim` endcoded in latin-1 .
`void` `fixedSizeMode(int size)` Flip the parser into fixed size mode, where the record size is specified by `size` in bytes.
`void` `handle(Buffer buffer)` This method is called to provide the parser with data.
`static byte[]` `latin1StringToBytes(java.lang.String str)` Helper method to convert a latin-1 String to an array of bytes for use as a delimiter Please do not use this for non latin-1 characters
`static RecordParser` `newDelimited(byte[] delim, Handler<Buffer> output)` Create a new `RecordParser` instance, initially in delimited mode, and where the delimiter can be represented by the `byte[]` delim.
`static RecordParser` `newDelimited(java.lang.String delim, Handler<Buffer> output)` Create a new `RecordParser` instance, initially in delimited mode, and where the delimiter can be represented by the String `` delim endcoded in latin-1 .
`static RecordParser` `newFixed(int size, Handler<Buffer> output)` Create a new `RecordParser` instance, initially in fixed size mode, and where the record size is specified by the `size` parameter.
`void` `setOutput(Handler<Buffer> output)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### setOutput

    public void setOutput(Handler<Buffer> output)

#### latin1StringToBytes

    public static byte[] latin1StringToBytes(java.lang.String str)

Helper method to convert a latin-1 String to an array of bytes for use as a delimiter Please do not use this for non latin-1 characters

Parameters:
  `str` -
Returns:
  The byte[] form of the string

#### newDelimited

    public static RecordParser newDelimited(java.lang.String delim,
                            Handler<Buffer> output)

Create a new `RecordParser` instance, initially in delimited mode, and where the delimiter can be represented by the String `` delim endcoded in latin-1 . Don't use this if your String contains other than latin-1 characters.

`output` Will receive whole records which have been parsed.

#### newDelimited

    public static RecordParser newDelimited(byte[] delim,
                            Handler<Buffer> output)

Create a new `RecordParser` instance, initially in delimited mode, and where the delimiter can be represented by the `byte[]` delim.

`output` Will receive whole records which have been parsed.

#### newFixed

    public static RecordParser newFixed(int size,
                        Handler<Buffer> output)

Create a new `RecordParser` instance, initially in fixed size mode, and where the record size is specified by the `size` parameter.

`output` Will receive whole records which have been parsed.

#### delimitedMode

    public void delimitedMode(java.lang.String delim)

Flip the parser into delimited mode, and where the delimiter can be represented by the String `delim` endcoded in latin-1 . Don't use this if your String contains other than latin-1 characters.

This method can be called multiple times with different values of delim while data is being parsed.

#### delimitedMode

    public void delimitedMode(byte[] delim)

Flip the parser into delimited mode, and where the delimiter can be represented by the delimiter `delim`.

This method can be called multiple times with different values of delim while data is being parsed.

#### fixedSizeMode

    public void fixedSizeMode(int size)

Flip the parser into fixed size mode, where the record size is specified by `size` in bytes.

This method can be called multiple times with different values of size while data is being parsed.

#### handle

    public void handle(Buffer buffer)

This method is called to provide the parser with data.

Specified by:
  `handle` in interface `Handler<Buffer>`
Parameters:
  `buffer` -